unit fGN_ESig;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  StdCtrls, ORFn, rCore, XWBHash, ORCtrls, fBase508Form,
  VA508AccessibilityManager,
  Vcl.ExtCtrls
  , u508Extensions
  ;

type
  TfrmSignItem = class(TfrmBase508Form)
    lblESCode: TLabel;
    lblText: TMemo;
    pnlBaseButtons: TPanel;
    cmdOK: u508Extensions.TButton;
    cmdCancel: u508Extensions.TButton;
    txtESCode: TCaptionEdit;
    procedure FormCloseQuery(Sender: TObject; var CanClose: Boolean);
    procedure FormKeyDown(Sender: TObject; var Key: Word; Shift: TShiftState);
  private
  public
    { Public declarations }
  end;

function getESig(const AText, ACaption: string): String;

implementation

{$R *.DFM}

uses uGN_Utils, VAUtils;

const
  TX_INVAL_MSG =
    'Not a valid electronic signature code.  Enter a valid code or press Cancel.';
  TX_INVAL_CAP = 'Unrecognized Signature Code';

function getESig(const AText, ACaption: string): String;
var
  frmSignItem: TfrmSignItem;
begin
  Result := '';
  frmSignItem := TfrmSignItem.Create(Application);
  try
    GN_ResizeAnchoredFormToFont(frmSignItem);
    with frmSignItem do
    begin
      Font.Size := Application.MainForm.Font.Size;
      Caption := ACaption;
      lblText.Text := AText;
      if ShowModal = mrOK then
        Result := Encrypt(txtESCode.Text);
    end;
  finally
    frmSignItem.Release;
  end;
end;

procedure TfrmSignItem.FormCloseQuery(Sender: TObject; var CanClose: Boolean);
begin
  inherited;
  if ModalResult <> mrCancel then
    if (txtESCode.Text = '') or not ValidESCode(txtESCode.Text) then
    begin
      InfoBox(TX_INVAL_MSG, TX_INVAL_CAP, MB_OK);
      if txtESCode.CanFocus then
        txtESCode.SetFocus;
      txtESCode.SelectAll;
      CanClose := False;
    end
    else
      CanClose := True;
end;

procedure TfrmSignItem.FormKeyDown(Sender: TObject; var Key: Word;
  Shift: TShiftState);
begin
  inherited;
  if Key = VK_ESCAPE then
  begin
    ModalResult := mrCancel;
    Key := 0;
  end;
end;

end.
