unit fGN_MainFrame;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, ExtCtrls, ComCtrls, ToolWin, StdCtrls, Menus,
  uCore, fGN_Page, uConst, fBase508Form, VA508AccessibilityManager,
  uPCE, ShellAPI, uInit, ORSystem, Vcl.Buttons, Vcl.ActnList,
  System.Actions, Vcl.StdActns, System.ImageList, Vcl.ImgList, System.UITypes,
  uGN_Const, Vcl.AppEvnts, HtmlHelpViewer, u508Extensions;

type
  TfrmGNMainFrame = class(TfrmBase508Form)
    pnlPage: TPanel;
    mnuGNMain: TMainMenu;
    Help1: TMenuItem;
    LastBroker1: TMenuItem;
    Font1: TMenuItem;
    Contents1: TMenuItem;
    N1: TMenuItem;
    About1: TMenuItem;
    File1: TMenuItem;
    Exit1: TMenuItem;
    alMain: TActionList;
    acPtSelector: TAction;
    acNoteCreate: TAction;
    acNewGroupNote: TAction;
    acExitGN: TAction;
    acTopToolbar: TAction;
    ools1: TMenuItem;
    oolbaratthetop1: TMenuItem;
    pnlMain: TPanel;
    acAbout: TAction;
    acLastRPC: TAction;
    acHelpPosition: TAction;
    HelpMenuonRight1: TMenuItem;
    acShowDisabled: TAction;
    ShowDisabledButtons1: TMenuItem;
    Debug1: TMenuItem;
    acChangeLog: TAction;
    N2: TMenuItem;
    ChangeLog1: TMenuItem;
    N3: TMenuItem;
    SelectPatients1: TMenuItem;
    CreateGroupNote1: TMenuItem;
    StartNewGroupNote1: TMenuItem;
    acDebugLayout: TAction;
    DebugLayout1: TMenuItem;
    sbMain: TStatusBar;
    ac8: TAction;
    ac10: TAction;
    ac12: TAction;
    ac14: TAction;
    ppFontSize: TPopupMenu;
    N81: TMenuItem;
    N101: TMenuItem;
    N121: TMenuItem;
    N141: TMenuItem;
    acAppLog: TAction;
    N82: TMenuItem;
    N102: TMenuItem;
    N122: TMenuItem;
    N142: TMenuItem;
    OneClickSelection1: TMenuItem;
    Select1: TMenuItem;
    OneClickSelection2: TMenuItem;
    ShowDisabledButtons2: TMenuItem;
    acEncounterRequired: TAction;
    CheckEncounter1: TMenuItem;
    HelpContents1: THelpContents;
    AppEv: TApplicationEvents;
    Inquiry1: TMenuItem;
    N4: TMenuItem;
    Remove1: TMenuItem;
    RemoveAll1: TMenuItem;
    acTimeout: TAction;
    N5: TMenuItem;
    N6: TMenuItem;
    acDebug: TAction;
    ChangeLog2: TMenuItem;
    tmrDebug: TTimer;
    pnlToolbar: TPanel;
    bvlTool: TBevel;
    bbCreate: u508Extensions.TButton;
    bbShow: u508Extensions.TButton;
    bbStart: u508Extensions.TButton;
    bbExit: u508Extensions.TButton;
    DebugInfo1: TMenuItem;
    procedure FormCreate(Sender: TObject);
    procedure LastBroker1Click(Sender: TObject);
    procedure FormClose(Sender: TObject; var Action: TCloseAction);
    procedure FormResize(Sender: TObject);
    procedure UMShowPage(var Message: TMessage); message UM_SHOWPAGE;
    procedure WMSetFocus(var Message: TMessage); message WM_SETFOCUS;
    procedure FormDestroy(Sender: TObject);
    procedure acPtSelectorExecute(Sender: TObject);
    procedure acNoteCreateExecute(Sender: TObject);
    procedure acNewGroupNoteExecute(Sender: TObject);
    procedure WindowClose1Execute(Sender: TObject);
    procedure acExitGNExecute(Sender: TObject);
    procedure acTopToolbarExecute(Sender: TObject);
    procedure acAboutExecute(Sender: TObject);
    procedure acLastRPCExecute(Sender: TObject);
    procedure acHelpPositionExecute(Sender: TObject);
    procedure acShowDisabledExecute(Sender: TObject);
    procedure acChangeLogExecute(Sender: TObject);
    procedure acDebugLayoutExecute(Sender: TObject);
    procedure ac8Execute(Sender: TObject);
    procedure ac10Execute(Sender: TObject);
    procedure ac12Execute(Sender: TObject);
    procedure ac18Execute(Sender: TObject);
    procedure ac14Execute(Sender: TObject);
    procedure FormShow(Sender: TObject);
    procedure acEncounterRequiredExecute(Sender: TObject);
    procedure FormActivate(Sender: TObject);
    function AppEvHelp(Command: Word; Data: NativeInt;
      var CallHelp: Boolean): Boolean;
    procedure HelpContents1Execute(Sender: TObject);

    procedure AppException(Sender: TObject; E: Exception);
    procedure acTimeoutExecute(Sender: TObject);
    procedure FormCloseQuery(Sender: TObject; var CanClose: Boolean);
    procedure AppEvMessage(var Msg: tagMSG; var Handled: Boolean);
    procedure tmrDebugTimer(Sender: TObject);
    procedure acDebugExecute(Sender: TObject);

  private
    FClosing: Boolean;
    fUserFontSize: Integer;
    FLastPage: TfrmPage;
    procedure ChangeFont(aNewFontSize: Integer);
    procedure timeOutAction;
    procedure setActionStatus;
    procedure adjustMenu;
    procedure AfterAppException(Sender: TObject; E: Exception);
  public
    property Closing: Boolean read FClosing;
    procedure SwitchTo(NewForm: TfrmPage);
    procedure _UM_GNMENU(var Message: TMessage); message UM_GNMENU;
    procedure _UM_GNSELECT(var Message: TMessage); message UM_GNSELECT;
    procedure _UM_GNDEBUG(var Message: TMessage); message UM_GNDEBUG;
    procedure _UM_GNSELECTPATIENT(var Message: TMessage);
      message UM_GNSELECTPATIENT;

    procedure _UM_GNNOTES_CREATED(var Message: TMessage);
      message UM_GNNOTES_CREATED;
    procedure _UM_GNENCOUNTERS_CREATED(var Message: TMessage);
      message UM_GNENCOUNTERS_CREATED;
  end;

var
  frmGNMainFrame: TfrmGNMainFrame;
  CloseFromMain: Boolean = False;
//  DEAContext: Boolean = False;         -- moved to uGlobalVar
//  DelayReviewChanges: Boolean = False; -- moved to uGlobalVar

implementation

{$R *.dfm}

uses ORNet, ORFn, Wsockc,System.Win.ComObj,
  fGN_PtSel, fGN_Encounter, rMisc, VAUtils, uGN_Utils,
  fGN_GroupEncounter, fGN_About, fEncounterFrame, uGN_ChangeLog, uGN_RPCLog,
  fRptBox, dmGN_Common, fGN_SelectedPatients, Math, TRPCB, U_HelpMGR,
  fGN_RPCLog, AVCatcher, rCore,
  fGN_Timeout, fDebugReport, VA508AccessibilityRouter, fGN_Debug, oGN_PtData;

procedure TfrmGNMainFrame.FormCreate(Sender: TObject);

  Procedure LoadExceptionLogger;
  var
    TmpLst: TStringList;
    TmpStr: String;
  begin
    TmpLst := TStringList.Create;
    try
      ExceptionLog.DaysToPurge := 60;
//        StrToIntDef(GetUserParam('OR CPRS EXCEPTION PURGE'), 60);
      ExceptionLog.Enabled := FindCmdLineSwitch('EXCEPTION_LOGGER');
//        StrToBoolDef(GetUserParam('OR CPRS EXCEPTION LOGGER'), False);
      GetUserListParam(TmpLst, 'OR CPRS EXCEPTION EMAIL');

      for TmpStr in TmpLst do
        ExceptionLog.EmailTo.Add(Piece(TmpStr, U, 2));
      ExceptionLog.OnAppException := AppException;
      ExceptionLog.OnAfterAppException := AfterAppException;
    finally
      TmpLst.Free;
    end;
  end;

  procedure setEncounter;
  var
    s: String;

    procedure setPanel(aPanel: TPanel; aValue: String; bHeight: Boolean = True);
    var
      i: Integer;
    begin
      i := StrToIntDef(aValue, 0);
      if i > 0 then
      begin
        if bHeight then
          aPanel.Height := i
        else
          aPanel.Width := i;
      end;
    end;

  begin
    if assigned(uBounds) and assigned(frmGNEncounter) then
      begin
        s := uBounds.Values[GN_ENCOUNTER_PANELS];
        setPanel(frmGNEncounter.pnlNote,piece(s,',',1));
        frmGNEncounter.BaseNoteHeight := StrToIntDef(piece(s,',',2),0);
        setPanel(frmGNEncounter.pnlLeft,piece(s,',',3), False);
        setPanel(frmGNPtSel.pnlTop,piece(s,',',4));
      end;
  end;

begin
  RPCLogInit;
  AddLogLine(StartupLine, 'Started as');

  setAfterRPCEvent(frmRPCLog.OnRefreshRPCRequest);
  SizeHolder := TSizeHolder.Create;

  User := TUser.Create;
{$IFDEF DEBUG} // don't let debug builds run in Production accounts
  if User.IsProductionAccount then
  begin
    MessageDLG('Sorry, the DEBUG build' + sLineBreak +
      'is not supported for production accounts', mtWarning, [mbOK], 0);
    FreeAndNil(User);
    Application.Terminate;
  end
  else
{$ENDIF}
  begin
    LoadExceptionLogger;

    Encounter := TEncounter.Create;
    Changes := TChanges.Create;

//    if User.IsProvider then - VISTAOR-29795 - Defaulting selection to application user
      Encounter.Provider := User.DUZ;

    Caption := TX_IN_USE + MixedCase(User.Name) + '  (' + RPCBrokerV.Server +
{$IFDEF DEBUG} ':' + IntToStr(RPCBrokerV.ListenerPort) + {$ENDIF} ')';

    sbMain.Panels[1].Text := MixedCase(User.Name);
    sbMain.Panels[2].Text := RPCBrokerV.Server + ':' +
      IntToStr(RPCBrokerV.ListenerPort);

    frmGNPtSel := TfrmGNPtSel.Create(self);
    setFormParented(frmGNPtSel, pnlPage);
    frmGNPtSel.OneClick := OneClickSelection1.Checked;

    frmGNEncounter := TfrmGNEncounter.Create(self);
    frmGNEncounter.Parent := pnlPage;
    frmGNEncounter.Align := alClient;
    frmGNEncounter.BorderStyle := bsNone;
    frmGNEncounter.acSelectPatients.Visible := acDebugLayout.Checked;

    Application.ShowHint := True; // rpk 1/21/2012   ICD-10

    fUserFontSize := UserFontSize;
    if fUserFontSize < 8 then
      fUserFontSize := 8;
    if fUserFontSize > 14 then
      fUserFontSize := 14;
    SetFontSize(fUserFontSize);

    SetUserBounds(TControl(frmGNMainFrame));
    setEncounter;

    adjustFormPosition(self);

//    acLastRPC.Visible := FindCmdLineSwitch('RPCLOG');

    SwitchTo(frmGNPtSel);

    GImplementationDate := GetImplementationDate();

    InitTimeOut(nil, timeOutAction);
    UpdateTimeOutInterval(User.DTIME * 1000);
{$IFDEF DEBUG}
//    Debug1.Visible := True;
{$ELSE}
//    Debug1.Visible := HasSecurityKey(GN_GUI_SECURITY_KEY); // 'GN GUI DEBUG'
    tmrDebug.Enabled := False;
{$ENDIF}
    SplashHide;

    if FindCmdLineSwitch('TESTRPC') then
      missingRPCList;
  end;
end;

procedure TfrmGNMainFrame.FormDestroy(Sender: TObject);
begin
  if assigned(Encounter) then
    Encounter.Free;
  if assigned(User) then
    User.Free;
  SizeHolder.Free;
  inherited;
end;

procedure TfrmGNMainFrame.SwitchTo(NewForm: TfrmPage);
var
  aPage: TfrmPage;
begin
  if FLastPage <> NewForm then
  begin
    aPage := fLastPage;

    if (aPage <> nil) then
    begin
      if assigned(aPage.Menu) then
        mnuGNMain.Unmerge(aPage.Menu);
      aPage.Hide;
    end;

    FLastPage := NewForm;
    if NewForm <> nil then
    begin
      if assigned(NewForm.Menu) then
        mnuGNMain.Merge(NewForm.Menu);
      NewForm.BringToFront;
      NewForm.FocusFirstControl;
      NewForm.Show;

      if ScreenReaderActive then
        begin
          GetScreenReader.Speak('Switching to ' + NewForm.Caption + ' form');
        end;
    end;
    Application.ProcessMessages;
  end;

  adjustMenu;
  setActionStatus;
end;

procedure TfrmGNMainFrame.LastBroker1Click(Sender: TObject);
begin
  ShowBroker;
end;

procedure TfrmGNMainFrame.ac10Execute(Sender: TObject);
begin
  inherited;
  ChangeFont(10);
end;

procedure TfrmGNMainFrame.ac12Execute(Sender: TObject);
begin
  inherited;
  ChangeFont(12);
end;

procedure TfrmGNMainFrame.ac18Execute(Sender: TObject);
begin
  inherited;
  ChangeFont(18);
end;

procedure TfrmGNMainFrame.ac8Execute(Sender: TObject);
begin
  inherited;
  ChangeFont(8);
end;

procedure TfrmGNMainFrame.ac14Execute(Sender: TObject);
begin
  inherited;
  ChangeFont(14);
end;

procedure TfrmGNMainFrame.acAboutExecute(Sender: TObject);
begin
  inherited;
  ShowAbout;
end;

procedure TfrmGNMainFrame.acChangeLogExecute(Sender: TObject);
begin
  inherited;
  ReportBox(ChangeLog, 'Change Log', False);
end;

procedure TfrmGNMainFrame.acDebugExecute(Sender: TObject);
begin
  inherited;
  ShowRTTI(nil);
end;

procedure TfrmGNMainFrame.acDebugLayoutExecute(Sender: TObject);
begin
  inherited;

  acDebugLayout.Checked := not acDebugLayout.Checked;

  SelectPatients1.Visible := not acDebugLayout.Checked;

  if assigned(frmGNEncounter) then
  begin
    frmGNEncounter.acDebugView.Checked := acDebugLayout.Checked;
    frmGNEncounter.acSelectPatients.Visible := acDebugLayout.Checked;
    if acDebugLayout.Checked then
      frmGNEncounter.setLayout('DEBUG')
    else
      frmGNEncounter.setLayout('');
  end;

  if assigned(frmGNPtSel) then
  begin
    if acDebugLayout.Checked then
      frmGNPtSel.setLayout('DEBUG')
    else
      frmGNPtSel.setLayout('');
  end;

  sbMain.Visible := acDebugLayout.Checked;

  if acDebugLayout.Checked then
  begin
    pnlToolbar.Align := alTop;
    bvlTool.Align := alTop;
    Caption := 'Group Notes/Encounters';
  end
  else
  begin
    pnlToolbar.Align := alBottom;
    bvlTool.Align := alBottom;
    Caption := TX_IN_USE + MixedCase(User.Name) + '  (' +
      RPCBrokerV.Server + ')';
  end;

  acTopToolbar.Checked := acDebugLayout.Checked;
  pnlToolbar.Visible := not acDebugLayout.Checked;

  setActionStatus;

//  MenuItemMoveRight(mnuGNMain.Handle, Debug1.Command);
//  width := width + 1;
//  Application.ProcessMessages;
//  width := width - 1;
end;

procedure TfrmGNMainFrame.acEncounterRequiredExecute(Sender: TObject);
begin
  inherited;
  acEncounterRequired.Checked := not acEncounterRequired.Checked;
end;

procedure TfrmGNMainFrame.acExitGNExecute(Sender: TObject);
begin
  inherited;
  Close;
end;

procedure TfrmGNMainFrame.acHelpPositionExecute(Sender: TObject);
begin
  inherited;
  acHelpPosition.Checked := not acHelpPosition.Checked;
  if acHelpPosition.Checked then
  begin
    adjustMenu;
    acHelpPosition.Enabled := False;
  end;
end;

procedure TfrmGNMainFrame.acLastRPCExecute(Sender: TObject);
begin
  inherited;
  ShowBroker;
end;

procedure TfrmGNMainFrame.acNewGroupNoteExecute(Sender: TObject);
begin
  if assigned(frmGNEncounter) then
    frmGNEncounter.DoStartOver
  else
    adjustMenu;
end;

procedure TfrmGNMainFrame.acNoteCreateExecute(Sender: TObject);
begin
  if GNPtList.Count < 1 then
    MessageDLG(TXT_NOSELECT, mtWarning, [mbOK], 0)
  else if acEncounterRequired.Checked and assigned(frmGNPtSel) and
    not frmGNPtSel.isComplete then
  begin
    MessageDLG(TXT_NOENCOUNTER, mtWarning, [mbOK], 0);
  end
  else
  begin
    if assigned(frmGNPtSel) then
      frmGNPtSel.setEncounter;

    if assigned(frmGNEncounter) then
      frmGNEncounter._PtList := GNPtList;

    GroupEdit := True;
    frmGNEncounter.doForAll(GroupEdit);

    SwitchTo(frmGNEncounter);
    StartOver := False;

    if acDebugLayout.Checked then
      frmGNEncounter.setLayout('DEBUG')
    else
      frmGNEncounter.setLayout('');

    frmGNEncounter.actForAllPatients.Enabled := GNPtList.Count > 1;
    frmGNEncounter.actForAllPatients.Checked := true;

  end;
end;

procedure TfrmGNMainFrame.acPtSelectorExecute(Sender: TObject);
begin
  with frmGNEncounter do
  begin
    if GroupEdit then
      SelectedPatient := ''
    else
    begin
      if lstPatients.ItemIndex > -1 then
        SelectedPatient :=
          TPatient(lstPatients.Items.Objects[lstPatients.ItemIndex]).DFN;
    end;
    GroupEdit := False;
  end;
  SwitchTo(frmGNPtSel);
end;

procedure TfrmGNMainFrame.acShowDisabledExecute(Sender: TObject);
begin
  inherited;
  acShowDisabled.Checked := not acShowDisabled.Checked;
  setActionStatus;
end;

procedure TfrmGNMainFrame.acTimeoutExecute(Sender: TObject);
begin
  inherited;
  if AllowTimeout then TimeoutAction;
end;

procedure TfrmGNMainFrame.acTopToolbarExecute(Sender: TObject);
begin
  inherited;
  acTopToolbar.Checked := not acTopToolbar.Checked;
  if acTopToolbar.Checked then
  begin
    pnlToolbar.Align := alTop;
    bvlTool.Align := alTop;
  end
  else
  begin
    pnlToolbar.Align := alBottom;
    bvlTool.Align := alBottom;
  end;
end;

procedure TfrmGNMainFrame.ChangeFont(aNewFontSize: Integer);
var
  i, iWidth: Integer;
  xScale, yScale: Real;

  procedure getScale(aSize: Integer; var X, Y: Real);
  begin
    X := TextWidthByFont(Font.Handle,
      'ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz') / 52;
    Y := getMainFormTextHeight;

    Font.Size := aSize;

    X := (TextWidthByFont(Font.Handle,
      'ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz') / 52) / X;
    Y := getMainFormTextHeight / Y;

    X := width * X;
    Y := height * Y;
  end;

begin
  Screen.MessageFont.Size := aNewFontSize; // RTC 1010989: fixing Msg font size

  getScale(aNewFontSize, xScale, yScale);
  Repaint;

  if assigned(frmGNPtSel) then
    frmGNPtSel.SetFontSize(aNewFontSize);
  if assigned(frmGNEncounter) then
    frmGNEncounter.SetFontSize(aNewFontSize);

  pnlToolbar.height := GAP_TOOLBAR + // default margins for panel and buttons
    getMainFormTextHeight;

  ac8.Checked := aNewFontSize = 8;
  ac10.Checked := aNewFontSize = 10;
  ac12.Checked := aNewFontSize = 12;
  ac14.Checked := aNewFontSize = 14;

  for i := 0 to pnlToolbar.ControlCount - 1 do
    if (pnlToolbar.Controls[i] is TBitBtn) and
      (TBitBtn(pnlToolbar.Controls[i]).Tag = 0) then
      adjustBitBtn(TBitBtn(pnlToolbar.Controls[i]))
    else
    if (pnlToolbar.Controls[i] is TButton) and
      (TButton(pnlToolbar.Controls[i]).Tag = 0) then
      adjustBtn(TButton(pnlToolbar.Controls[i]));

  if aNewFontSize > fUserFontSize then
  begin
    getScale(aNewFontSize, xScale, yScale);
    AdjustFormSize(self, round(xScale), round(yScale));
  end;

  adjustFormPosition(self);

  if Assigned(frmRPCLog) then
    frmRPCLog.setFontSize(aNewFontSize);

  fUserFontSize := aNewFontSize;

  if assigned(frmGNPtSel) then
    bbExit.width := frmGNPtSel.cmdCancel.width;

  iWidth := bbShow.width + bbCreate.width + bbStart.width + bbExit.width
    + GAP * 5;

  Application.ProcessMessages;

  if assigned(frmGNEncounter) then
  begin
    i := frmGNEncounter.getMinWidth;
    if iWidth < i + 12 then
      iWidth := i + 12;
  end;

  constraints.MinWidth := iWidth;
end;

procedure TfrmGNMainFrame.adjustMenu;
begin
  if assigned(FLastPage) and assigned(FLastPage.Menu) then
    mnuGNMain.Merge(FLastPage.Menu);
{$IFDEF DEBUG}
//  MenuItemMoveRight(mnuGNMain.Handle, Help1.Command);
//  MenuItemMoveRight(mnuGNMain.Handle, Debug1.Command); // DEBUG only visible
//  Application.ProcessMessages;
{$ENDIF}
end;

procedure TfrmGNMainFrame.FormActivate(Sender: TObject);
begin
  inherited;
  adjustMenu;
end;

procedure TfrmGNMainFrame.FormClose(Sender: TObject; var Action: TCloseAction);
var
  i: Integer;
  sl: TStringList;
begin
  FClosing := True;
  try
    ShutDownTimeout;
  except
    on E: Exception do
      InfoBox(E.Message, 'Error', MB_OK + MB_ICONERROR);
  end;

  try
    CleanPtList(GNPtList);
  except
    on E: Exception do
      InfoBox(E.Message,'Error',MB_OK + MB_ICONERROR);
  end;

  SaveUserFontSize(self.Font.Size);
  SaveUserBounds(self);   // -- only saves within SizeHolder
  sl := TStringList.Create;
  try
    if assigned(frmGNPtSel) then
      i := frmGNPtSel.splPatients.Top
    else
      i := 0;

    if assigned(frmGNEncounter) then
      with frmGNEncounter do
      begin
        sl.Add(strUserBounds2(GN_Encounter_Panels,
          pnlNote.Height,
          pnlBaseNote.Height,
          splPatients.Left,
          i));
      end;

    SizeHolder.AddSizesToStrList(sl);
    SaveUserSizes(sl);
  finally
    sl.Free;
  end;

  CloseFromMain := True;

  RPCLogSaveAll;

end;

procedure TfrmGNMainFrame.FormCloseQuery(Sender: TObject; var CanClose: Boolean);
begin
  inherited;
  if fClosing then
    CanClose := TRUE
  else
  CanClose := InfoBox('Do you want to close the "' +
    FileVersionValue(Application.ExeName,
      FILE_VER_FILEDESCRIPTION) + '" application?',
    'Closing Group Notes', MB_YESNO + MB_ICONQUESTION) = mrYES;
end;

procedure TfrmGNMainFrame.FormResize(Sender: TObject);
begin
  sbMain.Panels[1].width := 24 + Canvas.TextWidth(sbMain.Panels[1].Text);
  sbMain.Panels[2].width := 24 + Canvas.TextWidth(sbMain.Panels[2].Text);
  sbMain.Panels[0].width := sbMain.width - sbMain.Panels[1].width -
    sbMain.Panels[2].width;
  self.Repaint;
end;

procedure TfrmGNMainFrame.FormShow(Sender: TObject);
begin
  inherited;
  acDebug.Visible := FindCmdLineSwitch('DEBUG');
//  acChangeLog.Visible := FindCmdLineSwitch('DEBUG');
{$IFDEF DEBUG}
  if FindCmdLineSwitch('AAVIEW') and assigned(frmGNPtSel) and
    (frmGNPtSel.PatientsCount < 1) then
    PostMessage(Handle, UM_GNSELECTPATIENT, 0, 0);
{$ENDIF}
  ChangeFont(fUserFontSize);
end;

procedure TfrmGNMainFrame.HelpContents1Execute(Sender: TObject);
begin
  inherited;
  try
    LoadHelpFile(Application.HelpFile);
  finally
  end;
  Application.HelpContext(3);
end;

procedure TfrmGNMainFrame.UMShowPage(var Message: TMessage);
begin
  if FLastPage <> nil then
    FLastPage.DisplayPage;
end;

procedure TfrmGNMainFrame.WindowClose1Execute(Sender: TObject);
begin
  inherited;
  Close;
end;

procedure TfrmGNMainFrame.WMSetFocus(var Message: TMessage);
begin
  if (FLastPage <> nil) and (not(csDestroying in FLastPage.ComponentState)) and
    FLastPage.Visible then
    FLastPage.FocusFirstControl;
end;

procedure TfrmGNMainFrame.timeOutAction;
begin
  fClosing := True;
  Close;
  Application.Terminate;
end;

procedure TfrmGNMainFrame.tmrDebugTimer(Sender: TObject);
begin
  inherited;
  if assigned(ActiveControl) then
    Caption := ActiveControl.Name;
end;

procedure TfrmGNMainFrame.setActionStatus;
begin
  acPtSelector.Enabled := (FLastPage <> frmGNPtSel);

  if assigned(frmGNEncounter) then
    acPtSelector.Enabled := acPtSelector.Enabled and
      (not frmGNEncounter.NotesCreated) and
      (not frmGNEncounter.EncountersCreated);

  acNewGroupNote.Enabled := (FLastPage <> frmGNPtSel);

  acNoteCreate.Enabled := ((FLastPage = frmGNPtSel) and (GNPtList.Count > 0));
  acPtSelector.Visible := (acPtSelector.Enabled or acShowDisabled.Checked) and
    not acDebugLayout.Checked;
  acNewGroupNote.Visible := (acNewGroupNote.Enabled or acShowDisabled.Checked)
    and not acDebugLayout.Checked;
//  acNoteCreate.Visible := not acDebugLayout.Checked and
//    (acNoteCreate.Enabled or acShowDisabled.Checked);
end;

procedure TfrmGNMainFrame._UM_GNSELECT(var Message: TMessage);
begin
  if assigned(frmGNPtSel) then
  begin
    frmGNPtSel.setActionStatus;
    if frmGNPtSel.cboPatient.canFocus then
    try
      frmGNPtSel.cboPatient.setFocus;
    except
    end;
  end;
  setActionStatus;
end;

procedure TfrmGNMainFrame._UM_GNSELECTPATIENT(var Message: TMessage);
begin
  if assigned(frmGNEncounter) then
    frmGNEncounter.acSelectPatients.Execute;
end;

procedure TfrmGNMainFrame._UM_GNDEBUG(var Message: TMessage);
begin
  if assigned(frmEncounterFrame) then
    with frmEncounterFrame do
    begin
      mmLog.Visible := Message.WParam = 1;
      if mmLog.Visible then
        tabControl.Top := mmLog.height;
    end;
  Application.ProcessMessages;
end;

procedure TfrmGNMainFrame._UM_GNMENU(var Message: TMessage);
begin
  adjustMenu; //  mnuGNMain should be repainted
end;

procedure TfrmGNMainFrame._UM_GNNOTES_CREATED(var Message: TMessage);
begin
  acPtSelector.Enabled := False;
end;

procedure TfrmGNMainFrame._UM_GNENCOUNTERS_CREATED(var Message: TMessage);
begin
  acPtSelector.Enabled := False;
end;

procedure TfrmGNMainFrame.AppException(Sender: TObject; E: Exception);
const
  XWB_M_REJECT = 20000 + 2; // M error
var
  AnAddr: Pointer;
  ErrMsg: string;

begin
  Application.NormalizeTopMosts;
  if (E is EIntError) then
  begin
    ErrMsg := E.Message
{$IFDEF GROUPNOTES}
{$ELSE}
      + CRLF + 'CreateProgress: ' + IntToStr(FCreateProgress)
{$ENDIF}
      + CRLF + 'RPC Info: ' + RPCLastCall
    ;
    if EExternal(E).ExceptionRecord <> nil then
    begin
      AnAddr := EExternal(E).ExceptionRecord^.ExceptionAddress;
      ErrMsg := ErrMsg + CRLF + 'Address was ' + IntToStr(Integer(AnAddr));
    end;
    // Pass this message up
    E.Message := ErrMsg;
  end;

  if (E is EBrokerError)
{$IFDEF GROUPNOTES}
{$ELSE}
    or (E is EOleException)
{$ENDIF}
  then
  begin
{$IFDEF GROUPNOTES}
{$ELSE}
    FCreateProgress := FCP_FORMS;
{$ENDIF}
    // Option for custom action
    {
    if (E is EBrokerError) then
    begin
      if EBrokerError(E).Code = XWB_M_REJECT then
      begin
        ExceptionLog.CustomButtonCaption := 'Debug';
        ExceptionLog.OnCustomMethod := mnuDebugReportClick;
      end;
    end;
    }
    // Tell the exception logger that we can't continue
    ExceptionLog.TerminateApp := True;
  end;
  Application.RestoreTopMosts;
end;

procedure TfrmGNMainFrame.AfterAppException(Sender: TObject; E: Exception);
var
  RtnCursor: Integer;
begin
  // Option for custom action
  if (E is EBrokerError) then
  begin
    if EBrokerError(E).Code = XWB_M_REJECT then
    begin
      if RPCBrokerV.Connected then
      begin
        RtnCursor := Screen.cursor;
        Screen.cursor := crHourGlass;
        try
          LogBrokerErrors(E.Message);
        finally
          Screen.cursor := RtnCursor;
        end;
      end;
      // ExceptionLog.CustomButtonCaption := 'Debug';
      // ExceptionLog.OnCustomMethod := mnuDebugReportClick;
    end;
  end;

  if (E is EBrokerError) or (E is EOleException) then
  begin
{$IFDEF GROUPNOTES}
{$ELSE}
    FCreateProgress := FCP_FORMS;
{$ENDIF}
    // Tell the exception logger that we can't continue
    ExceptionLog.TerminateApp := True;
  end;
end;

function TfrmGNMainFrame.AppEvHelp(Command: Word; Data: NativeInt;
  var CallHelp: Boolean): Boolean;
var
  CrRtn: Integer;
begin
  try
    AppEv.CancelDispatch;
    CrRtn := Screen.Cursor;
    Screen.Cursor := crHourGlass;
    try
      LoadHelpFile(Application.HelpFile);
    finally
      Screen.Cursor := CrRtn;
    end;
    Result := True;
    HtmlHelp(Application.Handle, PChar(Application.HelpFile),
      HH_DISPLAY_TOC, 0);

    CallHelp := False;
  except
    Result := False;
    CallHelp := True;
  end;
end;

const
  EM_SETZOOM = (WM_USER + 225);

procedure TfrmGNMainFrame.AppEvMessage(var Msg: tagMSG; var Handled: Boolean);
var
  Control: TComponent;
begin
  Handled := False;
  if (Msg.Message = WM_MOUSEWHEEL) and (GetKeyState(VK_LBUTTON) < 0) then
  begin
    Control := FindControl(Msg.hwnd);
    if not assigned(Control) then
      Handled := True
    else if (Control is TRichEdit) then
    begin
      Handled := True;
      SendMessage(self.Handle, EM_SETZOOM, 0, 0);
    end;
  end;
  if Msg.Message = UM_OBJDESTROY then
  begin
    if (Msg.WParam <> 0) and (TObject(Msg.WParam) is TComponent) and
      not(csDestroying in TComponent(Msg.WParam).ComponentState) then
      TComponent(Msg.WParam).Free;
    Handled := True;
  end;
end;

end.
