unit fGN_Timeout;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  fBase508Form, ExtCtrls, StdCtrls, ORFn, VA508AccessibilityManager
  , u508Extensions
  ;

type
  TfrmTimeout = class(TfrmBase508Form) // replaces fAutoSz
    timCountDown: TTimer;
    pnlBottom: TPanel;
    btnClose: u508Extensions.TButton;
    cmdContinue: u508Extensions.TButton;
    pnlWarning: TPanel;
    pnlTop: TPanel;
    lblTitle: TStaticText;
    lblDontClose: TStaticText;
    lblCount: TStaticText;
    imgWarning: TImage;
    procedure FormCreate(Sender: TObject);
    procedure timCountDownTimer(Sender: TObject);
    procedure FormShow(Sender: TObject);
    procedure FormKeyDown(Sender: TObject; var Key: Word; Shift: TShiftState);
  private
    FCount: Integer;
  end;

function AllowTimeout: Boolean;

implementation

{$R *.DFM}

uses uCore, uGN_Utils, System.UITypes, VA508AccessibilityRouter;

function AllowTimeout: Boolean;
var
  frmTimeout: TfrmTimeout;
begin
  frmTimeout := TfrmTimeout.Create(Application);
  try
    Result := frmTimeout.ShowModal <> mrCancel;
  finally
    frmTimeout.Release;
  end;
end;

procedure TfrmTimeout.FormCreate(Sender: TObject);
begin
  inherited;
  Application.Restore;
  Application.BringToFront;
  MessageBeep(MB_ICONASTERISK);
  FCount := User.CountDown;
  lblCount.Caption := Format(' Closing in %2.0d seconds', [FCount]);
  Caption := Application.Title;
end;

procedure TfrmTimeout.FormKeyDown(Sender: TObject; var Key: Word;
  Shift: TShiftState);
begin
  inherited;
  if Key = VK_ESCAPE then
  begin
    Key := 0;
    ModalResult := mrCancel;
  end;
end;

procedure TfrmTimeout.FormShow(Sender: TObject);
begin
  inherited;
  SetForegroundWindow(Handle);

  Font.Size := Application.MainForm.Font.Size;
  lblCount.Font.Size := Font.Size + 4;
  imgWarning.Transparent := true;
  Application.ProcessMessages;

  lblTitle.Font.Style := lblTitle.Font.Style + [fsBold];
  clientwidth := getMainFormTextWidth(lblDontClose.Caption) + 80;

  pnlWarning.Height := getMainFormTextHeight * 3;

  adjustBtn(cmdContinue);
  adjustBtn(btnClose, true);
  clientheight := pnlBottom.Height + pnlWarning.Height * 2;
end;

procedure TfrmTimeout.timCountDownTimer(Sender: TObject);
begin
  inherited;
  if FCount = User.CountDown then
  begin
    MessageBeep(MB_ICONASTERISK);
    timCountDown.Enabled := False;
    timCountDown.Interval := 1000;
    timCountDown.Enabled := true;
  end;
  Dec(FCount);
  lblCount.Caption := Format(' Closing in %2.0d seconds', [FCount]);
  if ScreenReaderSystemActive and (fCount > 0) and (fCount mod 5 = 0) then
    GetScreenReader.Speak(lblCount.Caption);
  if FCount < 1 then
  begin
    timCountDown.Enabled := False;
    ModalResult := mrOK;
  end;
end;

end.
