unit fGN_Wait;

interface

uses
  Winapi.Windows, Winapi.Messages, System.SysUtils, System.Variants, System.Classes, Vcl.Graphics,
  Vcl.Controls, Vcl.Forms, Vcl.Dialogs, fBase508Form, Vcl.ExtCtrls, Vcl.StdCtrls;

type
  TfrmGN_Wait = class(TfrmBase508Form)
    pnlCanvas: TPanel;
    lblMessage: TLabel;
    pnlWait: TPanel;
  private
    { Private declarations }
  public
    { Public declarations }
  end;


procedure WaitShow(aText:String;aForm:TForm = nil);
procedure WaitHide;

implementation

uses
   VA508AccessibilityRouter;
{$R *.dfm}
var
  frmGN_Wait: TfrmGN_Wait;

procedure WaitShow(aText:String;aForm:TForm = nil);
var
  x,y:Integer;
  anOwner: TComponent;

begin
  if ScreenReaderSystemActive then
    exit;

  anOwner := aForm;
  if not assigned(anOwner) then
    anOwner := Application;

  if not Assigned(frmGN_Wait) then
     frmGN_Wait := TfrmGN_Wait.Create(anOwner);

  if Assigned(frmGN_Wait) then
    with frmGN_Wait do
    begin
      font.Assign(Application.MainForm.Font);
      lblMessage.Caption := aText;
      x := lblMessage.Canvas.textWidth(aText);
      y := lblMessage.Canvas.textHeight(aText);
      Width := 2* x + lblMessage.Margins.Left + lblMessage.Margins.Right;
      Height := y + lblMessage.Margins.Top + lblMessage.Margins.Bottom;
      Height := Height + pnlWait.Height;
      lblMessage.Caption := aText;
      Show;
    end;
  application.ProcessMessages;
end;

procedure WaitHide;
begin
  if ScreenReaderSystemActive then
    exit;

  if assigned(frmGN_Wait) then
  begin
    frmGN_Wait.Hide;
    FreeAndNil(frmGN_Wait);
  end;
end;


end.
